//----------------------------------------------------------------------//
// NyanFi																//
//  eLXgrA[̔zF												//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include "UserFunc.h"
#include "UserMdl.h"
#include "Global.h"
#include "TxtViewer.h"
#include "ColDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TColorDlg *ColorDlg;

//---------------------------------------------------------------------------
__fastcall TColorDlg::TColorDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::FormCreate(TObject *Sender)
{
	ColBufList = new TStringList();

	ColorListBox->Items->Text =
		"bgView=wiF\r\n"
		"fgView=F\r\n"
		"Margin=]\r\n"
		"bgRuler=[̔wiF\r\n"
		"fgRuler=[̖ڐF\r\n"
		"Cursor=CJ[\̐F\r\n"
		"selItem=Iڂ̔wiF\r\n"
		"fgSelItem=Iڂ̕F\r\n"
		"bgLineNo=sԍwiF\r\n"
		"LineNo=sԍF\r\n"
		"Mark=s}[N\r\n"
		"bdrLine=sԍE\r\n"
		"bdrFold=܂ԂE\r\n"
		"bdrFixed=Œ蒷\̏cr\r\n"
		"Comment=|Rg̕F\r\n"
		"Strings=̕F\r\n"
		"Reserved=\̕F\r\n"
		"Symbol=V{̕F\r\n"
		"Numeric=l̕F\r\n"
		"fgEmpBin1=oCiF1\r\n"
		"fgEmpBin2=oCiF2\r\n"
		"fgEmpBin3=oCiF3\r\n"
		"Headline=o̕F\r\n"
		"Ruby=r\r\n"
		"URL=URL̕F\r\n"
		"LocalLink=[Jt@Cւ̃N\r\n"
		"fgEmp=F\r\n"
		"bgEmp=wiF\r\n"
		"TAB=^u\F\r\n"
		"CR=s\F\r\n"
		"HR=r̐F\r\n"
		"Ctrl=Rg[R[h\r\n"
		"Folder=fBNg̕F\r\n"
		"Error=G[̕F\r\n";
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::FormShow(TObject *Sender)
{
	set_ListBoxItemHi(ColorListBox);

	ColBufList->Assign(TxtViewer->ColBufList);
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::FormDestroy(TObject *Sender)
{
	delete ColBufList;
}

//---------------------------------------------------------------------------
//ꗗ̕`
//---------------------------------------------------------------------------
void __fastcall TColorDlg::ColorListBoxDrawItem(TWinControl *Control, int Index, TRect &Rect,
		TOwnerDrawState State)
{
	draw_ColorListBox((TListBox*)Control, Rect, Index, State, ColBufList);
}

//---------------------------------------------------------------------------
//F̎Q
//---------------------------------------------------------------------------
void __fastcall TColorDlg::RefColBtnClick(TObject *Sender)
{
	TListBox *lp = ColorListBox;
	int idx = lp->ItemIndex;	if (idx==-1) return;

	UnicodeString col_nam = lp->Items->Names[idx];
	UserModule->ColorDlg->Color = (TColor)ColBufList->Values[col_nam].ToIntDef(clBlack);
	if (UserModule->ColorDlg->Execute()) {
		ColBufList->Values[col_nam] = IntToStr(UserModule->ColorDlg->Color);
		lp->Repaint();
	}
}

//---------------------------------------------------------------------------
//X|Cg
//---------------------------------------------------------------------------
void __fastcall TColorDlg::SpuitImageMouseDown(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y)
{
	if (Button==mbLeft && ColorListBox->ItemIndex!=-1)
		UserModule->BeginSpuit(SpuitPanel, SpuitImage);
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::SpuitImageMouseUp(TObject *Sender, TMouseButton Button,
		TShiftState Shift, int X, int Y)
{
	if (UserModule->SpuitEnabled()) {
		TColor col = UserModule->EndSpuit();
		TListBox *lp = ColorListBox;
		if (lp->ItemIndex!=-1) {
			ColBufList->Values[lp->Items->Names[lp->ItemIndex]] = col;
			lp->Repaint();
		}
	}
}

//---------------------------------------------------------------------------
//C|[g
//---------------------------------------------------------------------------
void __fastcall TColorDlg::InportBtnClick(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("zF̃C|[g"), F_FILTER_INI, _T("*.INI"));
	if (UserModule->OpenDlg->Execute()) {
		std::unique_ptr<UsrIniFile> inp_file(new UsrIniFile(UserModule->OpenDlg->FileName));
		inp_file->ReadSection("Color", ColBufList);
		ColorListBox->Repaint();
	}
	SetFocus();
}
//---------------------------------------------------------------------------
//GNX|[g
//---------------------------------------------------------------------------
void __fastcall TColorDlg::ExportBtnClick(TObject *Sender)
{
	UserModule->PrepareSaveDlg(_T("zF̃GNX|[g"), F_FILTER_INI, NULL);
	if (UserModule->SaveDlg->Execute()) {
		std::unique_ptr<UsrIniFile> exp_file(new UsrIniFile(UserModule->SaveDlg->FileName));
		exp_file->AssignSection("Color", ColBufList);
		if (!exp_file->UpdateFile(true)) msgbox_ERR(USTR_FaildSave);
	}
	SetFocus();
}
//---------------------------------------------------------------------------
//Ŝɔf
//---------------------------------------------------------------------------
void __fastcall TColorDlg::OptApplyBtnClick(TObject *Sender)
{
	if (msgbox_Sure(_T("Ŝ̃IvVݒɔf܂H"))) {
		TxtViewer->SetColor(ColBufList);
		TxtViewer->SetOptColor();
		TxtViewer->Repaint(true);
	}
}
//---------------------------------------------------------------------------
//Kp
//---------------------------------------------------------------------------
void __fastcall TColorDlg::ApplyBtnClick(TObject *Sender)
{
	TxtViewer->SetColor(ColBufList);
	TxtViewer->Repaint(true);
}

//---------------------------------------------------------------------------
//m
//---------------------------------------------------------------------------
void __fastcall TColorDlg::OkActionExecute(TObject *Sender)
{
	TxtViewer->SetColor(ColBufList);
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::OkActionUpdate(TObject *Sender)
{
	if (!UserModule->SpuitEnabled()) SpuitImage->Visible = (ColorListBox->ItemIndex!=-1);
}

//---------------------------------------------------------------------------
//LZ
//---------------------------------------------------------------------------
void __fastcall TColorDlg::CancelBtnClick(TObject *Sender)
{
	//X|Cg̃LZ
	if (UserModule->SpuitEnabled()) {
		UserModule->EndSpuit();
		SpuitImage->Visible = true;
	}
	//
	else ModalResult = mrCancel;
}

//---------------------------------------------------------------------------
//zF̖
//---------------------------------------------------------------------------
void __fastcall TColorDlg::DisableColActionExecute(TObject *Sender)
{
	TListBox *lp = ColorListBox;
	if (lp->ItemIndex!=-1) {
		ColBufList->Values[lp->Items->Names[lp->ItemIndex]] = IntToStr(clNone);
		lp->Invalidate();
	}
}
//---------------------------------------------------------------------------
void __fastcall TColorDlg::DisableColActionUpdate(TObject *Sender)
{
	TListBox *lp = ColorListBox;
	UnicodeString col_id = (lp->ItemIndex!=-1)? lp->Items->Names[lp->ItemIndex] : EmptyStr;
	((TAction*)Sender)->Enabled = contained_wd_i(_T("fgSelItem|bdrLine|bdrFold|bdrFixed"), col_id);
}

//---------------------------------------------------------------------------
//wv
//---------------------------------------------------------------------------
bool __fastcall TColorDlg::FormHelp(WORD Command, NativeInt Data, bool &CallHelp)
{
	if (Command==HELP_CONTEXT || Command==HELP_CONTEXTPOPUP) {
		HtmlHelpTopic(_T(HELPTOPIC_TV) _T("#SetColor"));
		CallHelp = false;
	}
	return true;
}
//---------------------------------------------------------------------------
