//----------------------------------------------------------------------//
// NyanFi																//
//  fBNgꊇ쐬_CAO										//
//----------------------------------------------------------------------//
#include <vcl.h>
#pragma hdrstop
#include <memory>
#include <System.DateUtils.hpp>
#include "Global.h"
#include "UserFunc.h"
#include "UserMdl.h"
#include "CreDirsDlg.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TCreateDirsDlg *CreateDirsDlg = NULL;

//---------------------------------------------------------------------------
__fastcall TCreateDirsDlg::TCreateDirsDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::FormShow(TObject *Sender)
{
	IniFile->LoadPosInfo(this, DialogCenter);

	StartEdit->Text = IniFile->ReadStrGen(_T("CreDirsDlgStart"));
	IncEdit->Text	= IniFile->ReadStrGen(_T("CreDirsDlgInc"));
	if (IniFile->ReadIntGen(_T("CreDirsDlgSerMod"), 1)>0)
		PstSerRadioBtn->Checked = true;
	else
		PreSerRadioBtn->Checked = true;
	StrEdit->Text	= IniFile->ReadStrGen(_T("CreDirsDlgStr"));
	if (IniFile->ReadIntGen(_T("CreDirsDlgStrMod"), 1)>0)
		PstStrRadioBtn->Checked = true;
	else
		PreStrRadioBtn->Checked = true;
	DtFmtEdit->Text    = IniFile->ReadStrGen(_T("CreDirsDlgDtFmt"));
	DateMaskEdit->Text = IniFile->ReadStrGen(_T("CreDirsDlgDate"), FormatDateTime("yyyy/01/01", Now()));
	if (IniFile->ReadIntGen(_T("CreDirsDlgDateMod"), 1)>0)
		PstDateRadioBtn->Checked = true;
	else
		PreDateRadioBtn->Checked = true;

	RefDir = IniFile->ReadStrGen(_T("CreDirsDlgRefDir"));

	ListMemo->Lines->Clear();
	ListMemo->SetFocus();
}
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::FormClose(TObject *Sender, TCloseAction &Action)
{
	IniFile->SavePosInfo(this);

	IniFile->WriteStrGen(_T("CreDirsDlgStart"),		StartEdit);
	IniFile->WriteStrGen(_T("CreDirsDlgInc"),		IncEdit);
	IniFile->WriteIntGen(_T("CreDirsDlgSerMod"),	PstSerRadioBtn->Checked? 1 : 0);
	IniFile->WriteStrGen(_T("CreDirsDlgStr"),		StrEdit);
	IniFile->WriteIntGen(_T("CreDirsDlgStrMod"),	PstStrRadioBtn->Checked? 1 : 0);
	IniFile->WriteStrGen(_T("CreDirsDlgDtFmt"),		DtFmtEdit);
	IniFile->WriteStrGen(_T("CreDirsDlgDate"),		DateMaskEdit->Text);
	IniFile->WriteIntGen(_T("CreDirsDlgDateMod"),	PstDateRadioBtn->Checked? 1 : 0);
	IniFile->WriteStrGen(_T("CreDirsDlgRefDir"),	RefDir);
}

//---------------------------------------------------------------------------
//AԂt
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::AddSerActionExecute(TObject *Sender)
{
	int sn	 = EditToInt(StartEdit);
	int dn	 = EditToInt(IncEdit, 1);
	int n_wd = StartEdit->Text.Length();

	cursor_HourGlass();
	UndoBuf = ListMemo->Lines->Text;
	std::unique_ptr<TStringList> lst(new TStringList());
	lst->Assign(ListMemo->Lines);
	for (int i=0; i<lst->Count; i++) {
		UnicodeString lbuf = lst->Strings[i];
		UnicodeString sno;
		sno.cat_sprintf(_T("%0*u"), n_wd, sn);
		if (PreSerRadioBtn->Checked) lbuf = sno + lbuf; else lbuf += sno;
		lst->Strings[i] = lbuf;
		sn += dn;
	}
	ListMemo->Lines->Assign(lst.get());
	cursor_Default();
}
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::AddSerActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !StartEdit->Text.IsEmpty() && EditToInt(IncEdit, 0)>0;
}
//---------------------------------------------------------------------------
//t
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::AddStrActionExecute(TObject *Sender)
{
	cursor_HourGlass();
	UndoBuf = ListMemo->Lines->Text;
	std::unique_ptr<TStringList> lst(new TStringList());
	lst->Assign(ListMemo->Lines);
	for (int i=0; i<lst->Count; i++) {
		UnicodeString lbuf = lst->Strings[i];
		if (PreStrRadioBtn->Checked) lbuf = StrEdit->Text + lbuf; else lbuf += StrEdit->Text;
		lst->Strings[i] = lbuf;
	}
	ListMemo->Lines->Assign(lst.get());
	cursor_Default();
}
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::AddStrActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !StrEdit->Text.IsEmpty();
}
//---------------------------------------------------------------------------
//tt
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::AddDateActionExecute(TObject *Sender)
{
	TDateTime dt;
	if (str_to_DateTime(DateMaskEdit->Text, &dt)) {
		cursor_HourGlass();
		UndoBuf = ListMemo->Lines->Text;
		std::unique_ptr<TStringList> lst(new TStringList());
		lst->Assign(ListMemo->Lines);
		UnicodeString fmt = DtFmtEdit->Text;
		int inc_mod = contains_s(fmt, _T('d'))? 0 : contains_s(fmt, _T('m'))? 1 : 2;
		for (int i=0; i<lst->Count; i++) {
			UnicodeString lbuf = lst->Strings[i];
			UnicodeString dbuf = FormatDateTime(DtFmtEdit->Text, dt);
			if (PreStrRadioBtn->Checked) lbuf = dbuf + lbuf; else lbuf += dbuf;
			lst->Strings[i] = lbuf;
			dt = (inc_mod==0)? IncDay(dt, 1) : (inc_mod==1)? IncMonth(dt, 1) : IncYear(dt, 1);
		}
		ListMemo->Lines->Assign(lst.get());
		cursor_Default();
	}
	else msgbox_ERR(USTR_IllegalDate);
}
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::AddDateActionUpdate(TObject *Sender)
{
	try {
		if (DtFmtEdit->Text.IsEmpty()) Abort();
		TDateTime(DateMaskEdit->Text);
		DateMaskEdit->Color = scl_Window;
		((TAction*)Sender)->Enabled = true;
	}
	catch (...) {
		DateMaskEdit->Color = col_Illegal;
		((TAction*)Sender)->Enabled = false;
	}
}

//---------------------------------------------------------------------------
//󍀖ڂǉ
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::AddEmptyItemClick(TObject *Sender)
{
	int n = inputbox_ex_n(_T("󍀖ڂǉ"), _T("ڐ"));
	if (n>0) {
		for (int i=0; i<n; i++) ListMemo->Lines->Add(EmptyStr);
	}
}

//---------------------------------------------------------------------------
//fBNg\Q
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::GetSubDirItemClick(TObject *Sender)
{
	UnicodeString dnam = RefDir;
	if (UserModule->SelectDirEx(_T("TufBNg擾"), dnam)) {
		cursor_HourGlass();
		StatusBar1->Panels->Items[0]->Text = "擾...";
		RefDir = dnam;
		std::unique_ptr<TStringList> lst(new TStringList());
		get_SubDirs(dnam, lst.get(), StatusBar1, 1);
		dnam = IncludeTrailingPathDelimiter(dnam);
		for (int i=0; i<lst->Count; i++) {
			UnicodeString lbuf = lst->Strings[i];
			remove_top_text(lbuf, dnam);
			lst->Strings[i] = lbuf;
		}
		lst->Sort();
		UndoBuf = ListMemo->Lines->Text;
		ListMemo->Lines->AddStrings(lst.get());
		cursor_Default();
	}
}

//---------------------------------------------------------------------------
//֎~̒u
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::RepCharItemClick(TObject *Sender)
{
	cursor_HourGlass();
	UndoBuf = ListMemo->Lines->Text;
	std::unique_ptr<TStringList> lst(new TStringList());
	lst->Assign(ListMemo->Lines);
	for (int i=0; i<lst->Count; i++) {
		UnicodeString lbuf = lst->Strings[i];
		for (int j=0; j<CnvCharList->Count; j++) {
			UnicodeString sch = CnvCharList->Names[j];	if (sch.IsEmpty()) continue;
			lbuf = ReplaceStr(lbuf, sch, CnvCharList->ValueFromIndex[j]);
		}
		lst->Strings[i] = lbuf;
	}
	ListMemo->Lines->Assign(lst.get());
	cursor_Default();
}

//---------------------------------------------------------------------------
//ɖ߂
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::UndoActionExecute(TObject *Sender)
{
	ListMemo->Lines->Text = UndoBuf;
	UndoBuf = EmptyStr;
}
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::UndoActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = !UndoBuf.IsEmpty();
}

//---------------------------------------------------------------------------
//XgɖOtĕۑ
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::SaveListActionExecute(TObject *Sender)
{
	UserModule->PrepareSaveDlg(_T("Xg̕ۑ"), F_FILTER_TXT, NULL);
	if (UserModule->SaveDlg->Execute() && !saveto_TextUTF8(UserModule->SaveDlg->FileName, ListMemo->Lines))
		msgbox_ERR(USTR_FaildSave);
}
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::SaveListActionUpdate(TObject *Sender)
{
	((TAction*)Sender)->Enabled = ListMemo->Lines->Count>0;
}
//---------------------------------------------------------------------------
//Xgt@Cǂݍ
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::LoadListActionExecute(TObject *Sender)
{
	UserModule->PrepareOpenDlg(_T("Xg̓ǂݍ"), F_FILTER_TXT, NULL);
	if (UserModule->OpenDlg->Execute()) {
		std::unique_ptr<TStringList> lst(new TStringList());
		if (load_text_ex(UserModule->OpenDlg->FileName, lst.get())!=0) {
			UndoBuf = ListMemo->Lines->Text;
			ListMemo->Lines->Assign(lst.get());
		}
		else msgbox_ERR(USTR_FileNotOpen);
	}
}
//---------------------------------------------------------------------------
//XgNA
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::ClearListItemClick(TObject *Sender)
{
	UndoBuf = ListMemo->Lines->Text;
	ListMemo->Lines->Clear();
}

//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::ListMemoKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (equal_ESC(get_KeyStr(Key, Shift))) ModalResult = mrCancel;
}

//---------------------------------------------------------------------------
//쐬
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::CreateActionExecute(TObject *Sender)
{
	int ok_cnt	= 0;
	for (int i=0; i<ListMemo->Lines->Count; i++)
		if (!ExtractFileName(ListMemo->Lines->Strings[i]).IsEmpty()) ok_cnt++;
	if (ok_cnt==0) {
		msgbox_ERR(USTR_NoObject);
		ModalResult = mrNone;
	}
}
//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::CreateActionUpdate(TObject *Sender)
{
	int itm_cnt = ListMemo->Lines->Count;
	((TAction*)Sender)->Enabled = itm_cnt>0;

	if (itm_cnt>0) {
		UnicodeString tmp;
		StatusBar1->Panels->Items[0]->Text = tmp.cat_sprintf(_T("ڐ: %u"), itm_cnt);
		StatusBar1->Panels->Items[1]->Text = EmptyStr;
	}
	else {
		StatusBar1->Panels->Items[0]->Text = EmptyStr;
		StatusBar1->Panels->Items[1]->Text = "쐬鍀ڂ͂ĂB";
	}
}

//---------------------------------------------------------------------------
void __fastcall TCreateDirsDlg::FormKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	SpecialKeyProc(this, Key, Shift);
}
//---------------------------------------------------------------------------
